# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from bosch_locator_bridge/ClientControlMode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ClientControlMode(genpy.Message):
  _md5sum = "b446a117691a6a9cb90b504feda8be3a"
  _type = "bosch_locator_bridge/ClientControlMode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Timestamp of the update
time stamp

# This mode is in RUN-state while a map is calculated live during the recording
uint8 visual_recording_state

# While a map is generated from a recording the ClientState of the Map mode is RUN
uint8 map_state

# This mode is in RUN-state while the system localizes itself to a map received from the Map Server
uint8 localization_state

#  This mode is in RUN-state while a recording is made
uint8 recording_state

# This mode is RUN-state while the user works on aligning the map
uint8 alignment_state

# This mode is RUN-state while the user is creating a mask for the laser scans
uint8 mask_state


# Constants
uint8 CLIENT_CONTROL_STATE_INIT=0
uint8 CLIENT_CONTROL_STATE_READY=1
uint8 CLIENT_CONTROL_STATE_RUN=2
uint8 CLIENT_CONTROL_STATE_NOT_AVAILABLE=4
"""
  # Pseudo-constants
  CLIENT_CONTROL_STATE_INIT = 0
  CLIENT_CONTROL_STATE_READY = 1
  CLIENT_CONTROL_STATE_RUN = 2
  CLIENT_CONTROL_STATE_NOT_AVAILABLE = 4

  __slots__ = ['stamp','visual_recording_state','map_state','localization_state','recording_state','alignment_state','mask_state']
  _slot_types = ['time','uint8','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,visual_recording_state,map_state,localization_state,recording_state,alignment_state,mask_state

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClientControlMode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.visual_recording_state is None:
        self.visual_recording_state = 0
      if self.map_state is None:
        self.map_state = 0
      if self.localization_state is None:
        self.localization_state = 0
      if self.recording_state is None:
        self.recording_state = 0
      if self.alignment_state is None:
        self.alignment_state = 0
      if self.mask_state is None:
        self.mask_state = 0
    else:
      self.stamp = genpy.Time()
      self.visual_recording_state = 0
      self.map_state = 0
      self.localization_state = 0
      self.recording_state = 0
      self.alignment_state = 0
      self.mask_state = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I6B().pack(_x.stamp.secs, _x.stamp.nsecs, _x.visual_recording_state, _x.map_state, _x.localization_state, _x.recording_state, _x.alignment_state, _x.mask_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.stamp.secs, _x.stamp.nsecs, _x.visual_recording_state, _x.map_state, _x.localization_state, _x.recording_state, _x.alignment_state, _x.mask_state,) = _get_struct_2I6B().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I6B().pack(_x.stamp.secs, _x.stamp.nsecs, _x.visual_recording_state, _x.map_state, _x.localization_state, _x.recording_state, _x.alignment_state, _x.mask_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.stamp.secs, _x.stamp.nsecs, _x.visual_recording_state, _x.map_state, _x.localization_state, _x.recording_state, _x.alignment_state, _x.mask_state,) = _get_struct_2I6B().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I6B = None
def _get_struct_2I6B():
    global _struct_2I6B
    if _struct_2I6B is None:
        _struct_2I6B = struct.Struct("<2I6B")
    return _struct_2I6B
