# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from bosch_locator_bridge/ClientGlobalAlignVisualization.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import bosch_locator_bridge.msg
import genpy

class ClientGlobalAlignVisualization(genpy.Message):
  _md5sum = "4f2c2636fd4a7412ce0228cd8f142446"
  _type = "bosch_locator_bridge/ClientGlobalAlignVisualization"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The time at which the Localization Client received the laser scan used to generate this Datagram
time timestamp

# A unique id for matching datagrams that were emitted at the same time but by different visualization interfaces
uint64 visualization_id

# A set of landmarks known to the system
bosch_locator_bridge/ClientGlobalAlignLandmarkVisualizationInformation[] landmarks

#Specifies which landmarks in the landmarks array were observed from which poses in
#the poses array. Note that some landmarks may have never been observed, and
#that some poses within the poses array may not be associated with any landmark.
bosch_locator_bridge/ClientGlobalAlignLandmarkObservationNotice[] observations

================================================================================
MSG: bosch_locator_bridge/ClientGlobalAlignLandmarkVisualizationInformation
# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Please note the the pose is directly published as PoseArray for visualization reasons
int64 type
bool has_orientation
string name

================================================================================
MSG: bosch_locator_bridge/ClientGlobalAlignLandmarkObservationNotice
# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

uint32 pose_index
uint32 landmark_index
"""
  __slots__ = ['timestamp','visualization_id','landmarks','observations']
  _slot_types = ['time','uint64','bosch_locator_bridge/ClientGlobalAlignLandmarkVisualizationInformation[]','bosch_locator_bridge/ClientGlobalAlignLandmarkObservationNotice[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,visualization_id,landmarks,observations

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClientGlobalAlignVisualization, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.visualization_id is None:
        self.visualization_id = 0
      if self.landmarks is None:
        self.landmarks = []
      if self.observations is None:
        self.observations = []
    else:
      self.timestamp = genpy.Time()
      self.visualization_id = 0
      self.landmarks = []
      self.observations = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2IQ().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id))
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _x = val1
        buff.write(_get_struct_qB().pack(_x.type, _x.has_orientation))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.observations)
      buff.write(_struct_I.pack(length))
      for val1 in self.observations:
        _x = val1
        buff.write(_get_struct_2I().pack(_x.pose_index, _x.landmark_index))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.landmarks is None:
        self.landmarks = None
      if self.observations is None:
        self.observations = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id,) = _get_struct_2IQ().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = bosch_locator_bridge.msg.ClientGlobalAlignLandmarkVisualizationInformation()
        _x = val1
        start = end
        end += 9
        (_x.type, _x.has_orientation,) = _get_struct_qB().unpack(str[start:end])
        val1.has_orientation = bool(val1.has_orientation)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        self.landmarks.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.observations = []
      for i in range(0, length):
        val1 = bosch_locator_bridge.msg.ClientGlobalAlignLandmarkObservationNotice()
        _x = val1
        start = end
        end += 8
        (_x.pose_index, _x.landmark_index,) = _get_struct_2I().unpack(str[start:end])
        self.observations.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2IQ().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id))
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _x = val1
        buff.write(_get_struct_qB().pack(_x.type, _x.has_orientation))
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.observations)
      buff.write(_struct_I.pack(length))
      for val1 in self.observations:
        _x = val1
        buff.write(_get_struct_2I().pack(_x.pose_index, _x.landmark_index))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.landmarks is None:
        self.landmarks = None
      if self.observations is None:
        self.observations = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id,) = _get_struct_2IQ().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = bosch_locator_bridge.msg.ClientGlobalAlignLandmarkVisualizationInformation()
        _x = val1
        start = end
        end += 9
        (_x.type, _x.has_orientation,) = _get_struct_qB().unpack(str[start:end])
        val1.has_orientation = bool(val1.has_orientation)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        self.landmarks.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.observations = []
      for i in range(0, length):
        val1 = bosch_locator_bridge.msg.ClientGlobalAlignLandmarkObservationNotice()
        _x = val1
        start = end
        end += 8
        (_x.pose_index, _x.landmark_index,) = _get_struct_2I().unpack(str[start:end])
        self.observations.append(val1)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2IQ = None
def _get_struct_2IQ():
    global _struct_2IQ
    if _struct_2IQ is None:
        _struct_2IQ = struct.Struct("<2IQ")
    return _struct_2IQ
_struct_qB = None
def _get_struct_qB():
    global _struct_qB
    if _struct_qB is None:
        _struct_qB = struct.Struct("<qB")
    return _struct_qB
