# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from bosch_locator_bridge/ClientMapVisualization.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ClientMapVisualization(genpy.Message):
  _md5sum = "8dd03d1d65c83775293ab6133751e6f6"
  _type = "bosch_locator_bridge/ClientMapVisualization"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The time at which the Localization Client received the laser scan used to generate this Datagram
time timestamp

# A unique id for matching datagrams that were emitted at the same time but by different visualization interfaces
uint64 visualization_id

# The ClientRecordingRecordingStatus
int32 status

# Distance traversed by the sensor since the last successful loop closure
float64 distanceToLastLC

# The relative delay within the system when processing laser scans.
# 0: no delay; 1.0 : delay causes loop closures to be omitted when building the temporary map
float64 delay

# Currently unused
float64 progress

# Please note that pose, scan, and path_poses is published directly via the standard message types (custom nested messages would hinder using ros tools, such as rviz)

#  Array of order state_1, state_2, using the ClientRecordingPathTypeEnum
int32[] path_types


# Constants
int32 CLIENT_RECORDING_RECORDING_STATUS_STARTUP = -2
int32 CLIENT_RECORDING_RECORDING_STATUS_DELAYED = 1
int32 CLIENT_RECORDING_RECORDING_STATUS_OK = 2

int32 CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL = 0
int32 CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE = 1
int32 CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE = 2
"""
  # Pseudo-constants
  CLIENT_RECORDING_RECORDING_STATUS_STARTUP = -2
  CLIENT_RECORDING_RECORDING_STATUS_DELAYED = 1
  CLIENT_RECORDING_RECORDING_STATUS_OK = 2
  CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL = 0
  CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE = 1
  CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE = 2

  __slots__ = ['timestamp','visualization_id','status','distanceToLastLC','delay','progress','path_types']
  _slot_types = ['time','uint64','int32','float64','float64','float64','int32[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,visualization_id,status,distanceToLastLC,delay,progress,path_types

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClientMapVisualization, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.visualization_id is None:
        self.visualization_id = 0
      if self.status is None:
        self.status = 0
      if self.distanceToLastLC is None:
        self.distanceToLastLC = 0.
      if self.delay is None:
        self.delay = 0.
      if self.progress is None:
        self.progress = 0.
      if self.path_types is None:
        self.path_types = []
    else:
      self.timestamp = genpy.Time()
      self.visualization_id = 0
      self.status = 0
      self.distanceToLastLC = 0.
      self.delay = 0.
      self.progress = 0.
      self.path_types = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2IQi3d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id, _x.status, _x.distanceToLastLC, _x.delay, _x.progress))
      length = len(self.path_types)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.Struct(pattern).pack(*self.path_types))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id, _x.status, _x.distanceToLastLC, _x.delay, _x.progress,) = _get_struct_2IQi3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.path_types = s.unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2IQi3d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id, _x.status, _x.distanceToLastLC, _x.delay, _x.progress))
      length = len(self.path_types)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.path_types.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.visualization_id, _x.status, _x.distanceToLastLC, _x.delay, _x.progress,) = _get_struct_2IQi3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.path_types = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2IQi3d = None
def _get_struct_2IQi3d():
    global _struct_2IQi3d
    if _struct_2IQi3d is None:
        _struct_2IQi3d = struct.Struct("<2IQi3d")
    return _struct_2IQi3d
